﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MapApp.Model;

namespace MapApp.Ui.Controls
{
    public partial class FrmInfo : AppFormBase
    {

        public FrmInfo()
        {
            InitializeComponent();
            CustomInitialize();
        }

        private void CustomInitialize()
        {
            FrmMain.Instance.MapControl.MapClick += new MapApp.Ui.Controls.GoogleMapControl.OnMapClick(MapControl_MapClick);
            FrmMain.Instance.MapControl.MapMouseMove += new MapApp.Ui.Controls.GoogleMapControl.OnMapMouseMove(MapControl_MapMouseMove);
        }

        void MapControl_MapMouseMove(MapApp.Ui.Controls.GoogleMapControl sender, MapApp.Model.MapLocation loc)
        {
            string msg = "Lat: " + loc.Lat +
                    ", Lng: " + loc.Lng;
            txtMouseLocation.Text = msg;
        }

        void MapControl_MapClick(MapApp.Ui.Controls.GoogleMapControl sender, MapApp.Ui.Controls.MapClickEventArgs e)
        {
            string msg = "Lat: " + e.MapLocation.Lat +
                    ", Lng: " + e.MapLocation.Lng;
            txtClickLocation.Text = msg;
        }

        private void btnDone_Click(object sender, EventArgs e)
        {
            this.Hide();
        }
    }
}
